<template>
  <div>
    <AdminConfigurator
      v-show="isAdminConfiguratorVisible"
      @close="closeAdminConfigurator"
      @update-projects="getAdminProjects"
    />
    <div class="p-6 pb-0">
      <UiButton class="px-4 rounded-16 w-max" @click="openAdminConfigurator">Create Project</UiButton>
    </div>
    <div class="flex flex-col gap-6 p-6">
      <div v-for="(project, index) in projects" :key="project.node_id + index" class="w-full rounded-16 bg-bgdtert">
        <AdminNodeCard
          :node-info="project"
          @toggle-menu="project.isMenuOpen = !project.isMenuOpen"
          @update-projects="getAdminProjects"
          @close-menu="project.isMenuOpen = false"
        />
      </div>
    </div>
    <UiPagination
      :current-page="currentPage"
      :pages-amount="5"
      class="absolute bottom-4 right-4"
      @change-page="currentPage = $event"
    />
  </div>
</template>

<script>
import { disableBodyScroll, enableBodyScroll } from 'body-scroll-lock';
import { getAdminProjects } from '@/api/admin';

import AdminConfigurator from '@/components/views/admin/AdminConfigurator.vue';
import UiButton from '@/components/ui/UiButton.vue';
import UiPagination from '@/components/ui/UiPagination.vue';
import AdminNodeCard from '@/components/views/admin/projects/AdminNodeCard.vue';

export default {
  name: 'ProjectList',

  components: { UiPagination, UiButton, AdminNodeCard, AdminConfigurator },

  data() {
    return {
      projectsPerPage: 10,
      currentPage: 1,

      projects: [],

      isAdminConfiguratorVisible: false,
    };
  },

  computed: {
    pagesAmount() {
      return 10;
    },
  },

  watch: {
    currentPage() {
      this.getAdminProjects();
    },
  },

  mounted() {
    this.getAdminProjects();
  },

  methods: {
    async getAdminProjects() {
      this.$store.commit('setAdminLoading', true);
      try {
        const res = await getAdminProjects({
          limit: this.projectsPerPage,
          offset: (this.currentPage - 1) * this.projectsPerPage,
        });
        this.projects = res.data.results.map((project) => ({ ...project, isMenuOpen: false }));
      } catch (err) {
        console.error(err);
      } finally {
        this.$store.commit('setAdminLoading', false);
      }
    },

    openAdminConfigurator() {
      this.isAdminConfiguratorVisible = true;
      const el = document.querySelector('#adminConfigurator');
      disableBodyScroll(el);
    },

    closeAdminConfigurator() {
      this.isAdminConfiguratorVisible = false;
      const el = document.querySelector('#adminConfigurator');
      enableBodyScroll(el);
    },
  },
};
</script>
